#include <algorithm>
#include <fstream>
#include <iostream>
#include <limits>
#include <vector>

using namespace std;

#ifdef EVAL
ifstream in("input.txt");
ofstream out("output.txt");
#else
istream& in(cin);
ostream& out(cout);
#endif


long int count_crossings(const vector<int>& test,
                    const vector<pair<int, int>>& edges) {
    vector<int> rev(test.size());
    for (int i = 0; i < test.size(); i++) {
        rev[test[i]] = i;
    }

    long int ncross = 0;
    for (int i = 0; i < edges.size(); i++) {
        for (int j = i + 1; j < edges.size(); j++) {
            if ((edges[i].second - edges[j].second) *
                    (rev[edges[i].first] - rev[edges[j].first]) < 0) {
                ncross++;
            }
        }
    }

    return ncross;
}


int main() {
    int N_a, N_b, M;
    vector<pair<int, int>> edges;

    in >> N_a >> N_b >> M;
    for (int i = 0; i < M; i++) {
        int a, b;
        in >> a >> b;
        edges.push_back(make_pair(a, b));
    }

    vector<int> A_order(N_a);
    // fill numbers from 0 to N
    for (int i = 0; i < N_a; ++i) {
        A_order[i] = i;
    }

    // initialize ncross to the initial number of crossings
    long int ncross = count_crossings(A_order, edges);

    /*
     * print the solution, i. e. the initial order
     *
     * 0 1 ... N_A-1
     */
    out << ncross << endl;
    for (int a : A_order) {
        out << a << " ";
    }
    out << endl;
    out << "***" << endl;

    return 0;
}
